import checkers.quals.*;
import java.util.*;

class RawTypes {
    
    class Bad {
        @NonNull String field;
        
        public Bad() {
            init();                                     // error
            this.field = "field";
        }
        
        void init() {
            System.out.println(this.field.length());
        }
    }
    
    class A {
        @NonNull String field;
    
        public A() {
            this.field = "field";
            init();
        }
        
        public void init() @Raw {
            System.out.println(this.field.length());             // error
        }
    }
    
    class B extends A {
        @NonNull String otherField;
        
        public B() {
            super();
            this.otherField = "otherField";
        }
        
        @Override
        public void init() @Raw {
            System.out.println(this.field.length());            // error (TODO: ?)
            System.out.println(this.otherField.length());       // error
        }
    }
}